
#include-once

;### MathExBal_GetTrajectory ##############################################################################################
;Syntax ..................: MathExBal_GetTrajectory($Height, $Alpha, $Speed, $Gravity=9.81,$To=10000,$AirResistance=0)
;Beschreibung ............: Berechnet die Flugbahn mit oder ohne Luftwiderstand
;Variablen ...............: $Height				Die Anfangshhe
;							$Alpha				Der Startwinkel
;							$Speed				Die Startgeschwindigkeit
;							$Gravity=9.81		Die Gravitation (Standard ist die Gravitation der Erde)
;							$To=10000			Die Anzahl der zu berechnenden Werte
;							$AirResistance=False	Der Luftwiderstand (Standardmig aus)
;Rckgabe ................: Erfolg:				Gibt ein Array zurck mit den y-Werten.
;							Fehler:				0, setzt @error
;							@error:				1 	
;Bemerkungen .............: Ich habe noch keinen Abschnitt fr den Luftwiderstand. Wenn man $AirResistance=True setzt wird
;							nichts zurckgegeben... Das kommt aber noch. ;)
;###########################################################################################################################
Func MathExBal_GetTrajectory($Heigth, $Alpha, $Speed, $Gravity=9.81,$To=10000,$AirResistance=False)
   If Not IsNumber($Heigth) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($Alpha) Or $Alpha<0 Or $Alpha>360 Then
	  SetError(2)
	  Return 0
   EndIf
   If Not IsNumber($Speed) Then
	  SetError(3)
	  Return 0
   EndIf
   If Not IsNumber($Gravity) Then
	  SetError(4)
	  Return 0
   EndIf
   If Not IsNumber($To) Then
	  SetError(5)
	  Return 0
   EndIf
   If Not IsBool($AirResistance) Then
	  SetError(6)
	  Return 0
   EndIf
   If $AirResistance=False Then
	  Dim $Return[$To]
	  For $x=0 To $To-1
		 $Return[$x]=$Heigth+$x*Tan($Alpha*$MATHEX_CONST_RADIAN)-1/2*$Gravity*(MathExBas_Power($x)/MathExBas_Power($Speed)*MathExBas_Power(Cos($Alpha*$MATHEX_CONST_RADIAN)))
	  Next
   ElseIf $AirResistance=True Then
	  ;TODO
   EndIf
   Return $Return
EndFunc