
#include-once

;### MathExBas_Power #######################################################################################################
;Syntax ..................: MathExBas_Power($Number,$n=2)
;Beschreibung ............: Potenziert eine Zahl n-mal
;Variablen ...............: $Number				Die zu potenzierende Zahl
;							$n=2				Die anzahl der Potenzierungen
;Rckgabe ................: Erfolg:				Na was wohl?
;							Fehler:				0, setzt @error
;							@error:				1 	$Number ist keine Zahl
;												2	$n ist nicht Integer
;###########################################################################################################################
Func MathExBas_Power($Number,$n=2)
   If Not IsNumber($Number) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsInt($n) Then
	  SetError(2)
	  Return 0
   EndIf
   For $i=1 To $n-1
	  $Number=$Number*$Number
   Next
   Return $Number
EndFunc

;### MathExBas_Root ########################################################################################################
;Syntax ..................: MathExBas_Root($Number,$n=2)
;Beschreibung ............: Zieht die Wurzel einer Zahl n-mal
;Variablen ...............: $Number				Die zu verwurzelnde Zahl
;							$n=2				Die anzahl der Wurzelzge
;Rckgabe ................: Erfolg:				Na was wohl?
;							Fehler:				0, setzt @error
;							@error:				1 	$Number ist keine Zahl
;												2	$n ist nicht Integer
;###########################################################################################################################
Func MathExBas_Root($Number,$n=2)
   If Not IsNumber($Number) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsInt($n) Then
	  SetError(2)
	  Return 0
   EndIf
   For $i=1 To $n-1
	  $Number=Sqrt($Number)
   Next
   Return $Number
EndFunc