
#include-once

;### MathExTri #############################################################################################################
;Bemerkungen .............: Um die Gre des Skriptes zu verringern habe ich die Variablennamen verallgemeinert:
;							Variable			Beschreibung		Name
;							$a					Seitenlnge a		a
;							$b					Seitenlnge b		b
;							$c					Seitenlnge c		c
;							$ALPHA				Winkel Alpha		ALPHA
;							$BETA				Winkel Beta			BETA
;							$GAMMA				Winkel Gamma		GAMMA
;												Umfang				Circumference
;												Hhe				Heigth
;												Oberflche			Surface
;
;							Man muss aus dem Syntax den Sinn der Funktion herauslesen, aber das sollte machbar sein. ;)
;							Auerdem gibt es verschiedene Typen von Dreiecken:
;							MathExTri_General						Alle Dreiecke
;							MathExTri_Equilateral					Gleichseitige Dreiecke
;							MathExTri_RightAngle					Rechtwinkliges Dreieck
;
;							Die Fehlercodes (@error) werden in der Reihenfolge, wie die Variablen aufeinanderfolgen
;							zurckgegeben. (Winkel mssen von 0-180 gehen ; Lngen mssen Zahlen sein) Beispiel:
;							MathExTri_General_a($b,$c,$ALPHA)	@error=1	$b ist keine Zahl
;																@error=2	$c ist keine Zahl
;																@error=3	$ALPHA ist grer als 360, kleiner als 0 oder
;																			keine Zahl
;###########################################################################################################################
Func MathExTri_General_a($b,$c,$ALPHA)
   If Not IsNumber($b) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($c) Then
	  SetError(2)
	  Return 0
   EndIf
   If Not IsNumber($ALPHA) Or $ALPHA<0 Or $ALPHA>180 Then
	  SetError(1)
	  Return 0
   EndIf
   Return Sqrt(MathExBas_Power($c)+MathExBas_Power($b)-2*$b*$c*Cos($ALPHA))
EndFunc

Func MathExTri_General_b($a,$c,$BETA)
   If Not IsNumber($a) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($c) Then
	  SetError(2)
	  Return 0
   EndIf
   If Not IsNumber($BETA) Or $BETA<0 Or $BETA>180 Then
	  SetError(1)
	  Return 0
   EndIf
   Return Sqrt(MathExBas_Power($c)+MathExBas_Power($a)-2*$a*$c*Cos($BETA))
EndFunc

Func MathExTri_General_c($a,$b,$GAMMA)
   If Not IsNumber($a) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($b) Then
	  SetError(2)
	  Return 0
   EndIf
   If Not IsNumber($GAMMA) Or $GAMMA<0 Or $GAMMA>180 Then
	  SetError(1)
	  Return 0
   EndIf
   Return Sqrt(MathExBas_Power($a)+MathExBas_Power($b)-2*$a*$b*Cos($GAMMA))
EndFunc

Func MathExTri_General_Circumference($a,$b,$c)
   If Not IsNumber($a) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($b) Then
	  SetError(2)
	  Return 0
   EndIf
   If Not IsNumber($c) Then
	  SetError(3)
	  Return 0
   EndIf
   Return $a+$b+$c
EndFunc

Func MathExTri_General_Heigth($a,$b,$c)
   If Not IsNumber($a) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($b) Then
	  SetError(2)
	  Return 0
   EndIf
   If Not IsNumber($c) Then
	  SetError(3)
	  Return 0
   EndIf
   Return $a*$b/$c
EndFunc

Func MathExTri_General_Surface($a,$b)
   If Not IsNumber($a) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($b) Then
	  SetError(2)
	  Return 0
   EndIf
   Return ($a*$b)/2
EndFunc



Func MathExTri_Equilateral_Heigth($a)
   If Not IsNumber($a) Then
	  SetError(1)
	  Return 0
   EndIf
   Return Sqrt(3)/2*$a
EndFunc

Func MathExTri_Equilateral_Surface($a)
   If Not IsNumber($a) Then
	  SetError(1)
	  Return 0
   EndIf
   Return MathExBas_Power($a)*Sqrt(3)/4
EndFunc

Func MathExTri_Equilateral_Circumference($a)
   If Not IsNumber($a) Then
	  SetError(1)
	  Return 0
   EndIf
   Return 3*$a
EndFunc



Func MathExTri_RightAngle_a($b,$c)
   If Not IsNumber($b) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($c) Then
	  SetError(2)
	  Return 0
   EndIf
   Return Sqrt(MathExBas_Power($c)-MathExBas_Power($b))
EndFunc

Func MathExTri_RightAngle_b($a,$c)
   If Not IsNumber($a) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($c) Then
	  SetError(2)
	  Return 0
   EndIf
   Return Sqrt(MathExBas_Power($c)-MathExBas_Power($a))
EndFunc

Func MathExTri_RightAngle_c_1($a,$b)
   If Not IsNumber($a) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($b) Then
	  SetError(2)
	  Return 0
   EndIf
   Return Sqrt(MathExBas_Power($a)+MathExBas_Power($b))
EndFunc

Func MathExTri_RightAngle_c_2($b,$ALPHA)
   If Not IsNumber($b) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($ALPHA) Or $ALPHA<0 Or $ALPHA>180 Then
	  SetError(2)
	  Return 0
   EndIf
   Return $b/Cos($ALPHA)
EndFunc

Func MathExTri_RightAngle_ALPHA_1($a,$c)
   If Not IsNumber($a) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($c) Then
	  SetError(2)
	  Return 0
   EndIf
   Return _Degree(ASin($a/$c))
EndFunc

Func MathExTri_RightAngle_ALPHA_2($b,$c)
   If Not IsNumber($b) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($c) Then
	  SetError(2)
	  Return 0
   EndIf
   Return _Degree(ACos($b/$c))
EndFunc

Func MathExTri_RightAngle_ALPHA_3($a,$b)
   If Not IsNumber($a) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($b) Then
	  SetError(2)
	  Return 0
   EndIf
   Return _Degree(ATan($a/$b))
EndFunc

Func MathExTri_RightAngle_BETA($b,$a)
   If Not IsNumber($b) Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($a) Then
	  SetError(2)
	  Return 0
   EndIf
   Return _Degree(ATan($b/$a))
EndFunc

Func MathExTri_RightAngle_GAMMA($ALPHA,$BETA)
   If Not IsNumber($ALPHA) Or $ALPHA<0 Or $ALPHA>180 Then
	  SetError(1)
	  Return 0
   EndIf
   If Not IsNumber($BETA) Or $BETA<0 Or $BETA>180 Then
	  SetError(2)
	  Return 0
   EndIf
   Return $ALPHA+$BETA
EndFunc